=== debian/changelog ===
cpu-x (5.2.0-0.4) unstable; urgency=medium

  * NMU
  * Trigger build on x32 by bumping libcpuid-dev build dependency to 0.7.1

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Mar 2025 10:19:09 +0000

cpu-x (5.2.0-0.3) unstable; urgency=medium

  * NMU
  * Build depend on libcpuid on x32

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 23 Mar 2025 16:46:17 +0000

cpu-x (5.2.0-0.2) unstable; urgency=medium

  * NMU
  * Patch to allow arch i686 instead of just X86
  * Add arm and x32 architectures to debian/control file

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 23 Mar 2025 14:39:38 +0000

cpu-x (5.2.0-0.1) unstable; urgency=medium

  * NMU
  * New upstream release
  * Update build dependencies:
    - tighten cmake version requirement
    - need libegl-dev instead of libglfw3-dev
    - need opencl-headers; opencl now on by default
  * Forward port quilt patches

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 22 Mar 2025 15:17:24 +0000
