## cpu-x 5.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,31 @@
 	cmake_policy(SET CMP0177 NEW)
 endif()
 project(cpu-x
-	VERSION "5.2.0"
+	VERSION "5.3.1"
 	LANGUAGES C CXX
 )
 
+# Check for x86 CPU
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$|(x86)|(X86)|(amd64)|(AMD64)")
+	set(CPU_ISA_X86 TRUE)
+else()
+	set(CPU_ISA_X86 FALSE)
+endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$|(x86)|(X86)|(amd64)|(AMD64)")
+
+# Check for ARM CPU
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64")
+	set(CPU_ISA_ARM TRUE)
+else()
+	set(CPU_ISA_ARM FALSE)
+endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64")
+
+# Check if platform is supported
 if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
 	message(WARNING "'${CMAKE_SYSTEM_NAME}' system is not officially supported by CPU-X, some features will not be available.")
 endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
-if(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|^armv.*|aarch64")
-	message(FATAL_ERROR "'${CMAKE_SYSTEM_PROCESSOR}' processor is not supported by CPU-X.")
-endif(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|^armv.*|aarch64")
+if(NOT CPU_ISA_X86 AND NOT CPU_ISA_ARM)
+	message(WARNING "'${CMAKE_SYSTEM_PROCESSOR}' processor is not officially supported by CPU-X, some features will not be available.")
+endif(NOT CPU_ISA_X86 AND NOT CPU_ISA_ARM)
 
 
 ### DEFAULT CONFIG
@@ -71,11 +86,11 @@
 option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
 option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
 option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+if(CPU_ISA_X86)
 	option(WITH_BANDWIDTH "Built-in Bandwidth"                                                ON) # Bandwidth is only supported on x86 CPUs (requires cache size)
 else()
 	set(WITH_BANDWIDTH OFF)
-endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+endif(CPU_ISA_X86)
 option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
 option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)
 option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)
@@ -100,26 +115,49 @@
 set(BoldWhite   "${Esc}[1;37m")
 
 
+### FUNCTIONS
+
+# Credits to jtanx: https://gist.github.com/jtanx/96ded5e050d5ee5b19804195ee5cf5f9
+# Function: pad_string(output str padchar length)
+# Add padding to a string
+# @output:  variable name for output string
+# @str:     input string
+# @padchar: character used for padding
+# @length:  padding length
+function(pad_string output str padchar length)
+	string(LENGTH "${str}" _strlen)
+	math(EXPR _strlen "${length} - ${_strlen}")
+	if(_strlen GREATER 0)
+		if(${CMAKE_VERSION} VERSION_LESS "3.14")
+			unset(_pad)
+			foreach(_i RANGE 1 ${_strlen}) # inclusive
+				string(APPEND _pad ${padchar})
+			endforeach()
+		else()
+			string(REPEAT ${padchar} ${_strlen} _pad)
+		endif()
+		string(APPEND str ${_pad})
+	endif()
+	set(${output} "${str}" PARENT_SCOPE)
+endfunction()
+
+
 ### MACROS
 
-# Macro: print_config(libname foundstate withstate)
+# Macro: print_config(libname libver withstate)
 # Print the state of CPU-X features: in bold green if enabled, else bold red.
 # @libname:    library name (e.g. GTK)
 # @libver:     library version (e.g. XXXXX_VERSION)
-# @foundstate: the result of pkg_check_modules(...) (e.g. XXXXX_FOUND)
 # @withstate:  the CMake option which allows to disable this feature (e.g. WITH_XXXXX)
-macro(print_config libname libver foundstate withstate)
-	if(${foundstate} AND ${withstate})
-		message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset}")
+macro(print_config libname libver withstate)
+	pad_string(lib_string ${libname} " " 15)
+	if(${withstate})
+		message("${BoldCyan}**   ${lib_string}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset} (version is ${libver})")
 		add_definitions(-DHAS_${libname}=1 -D${libname}_VERSION="${libver}")
-	else(${foundstate} AND ${withstate})
-		if(NOT ${withstate})
-			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (explicitly disabled)")
-		elseif(NOT ${foundstate})
-			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (not found by pkg-config)")
-		endif()
+	else(${withstate})
+		message("${BoldCyan}**   ${lib_string}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset}")
 		add_definitions(-DHAS_${libname}=0 -D${libname}_VERSION=NULL)
-	endif(${foundstate} AND ${withstate})
+	endif(${withstate})
 endmacro(print_config)
 
 
@@ -147,15 +185,16 @@
 find_package(Backtrace REQUIRED)
 find_package(Filesystem REQUIRED)
 if(WITH_GETTEXT)
-	find_package(Gettext)
+	find_package(Gettext REQUIRED)
 	if(${CMAKE_VERSION} VERSION_GREATER "3.1")
-		find_package(Intl)
+		find_package(Intl REQUIRED)
 	endif(${CMAKE_VERSION} VERSION_GREATER "3.1")
 endif(WITH_GETTEXT)
-include(CheckSymbolExists)
-include(CheckStructHasMember)
-include(CheckCSourceCompiles)
-include(CheckIncludeFile)
+#include(CheckSymbolExists)
+#include(CheckStructHasMember)
+#include(CheckCSourceCompiles)
+#include(CheckIncludeFile)
+include(CheckLanguage)
 add_subdirectory(data)
 add_subdirectory(po)
 add_subdirectory(src)
