=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,30 +11,25 @@
 
 # GTK3+
 if(WITH_GTK)
-	set(MINIMUM_GTK_VERSION 3.12.0)
-	pkg_check_modules(GTK3 gtkmm-3.0>=${MINIMUM_GTK_VERSION})
+	pkg_check_modules(GTK3 REQUIRED gtkmm-3.0>=3.12.0)
 	if(GTK3_FOUND)
 		include_directories(${GTK3_INCLUDE_DIRS})
 		link_directories(${GTK3_LIBRARY_DIRS})
 		add_definitions(${GTK3_CFLAGS_OTHER})
-	else(GTK3_FOUND)
-		message("${BoldYellow}GTK3+ GUI will not be build:${ColourReset} ${Yellow}GTK ${MINIMUM_GTK_VERSION} or higher is needed.${ColourReset}")
-		message("${Yellow}Set ${BoldYellow}PKG_CONFIG_PATH${ColourReset}${Yellow} environment variable if development files are installed.${ColourReset}")
 	endif(GTK3_FOUND)
 endif(WITH_GTK)
 
 # NCurses
 if(WITH_NCURSES)
-	pkg_check_modules(NCURSES ncursesw)
-	# Assume ncurses from the base on FreeBSD
-	if(NOT NCURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
-		set(NCURSES_FOUND 1)
-		set(NCURSES_LIBRARIES "-l:libncursesw.so")
-	endif()
-	if(NCURSES_FOUND)
-		include_directories(${NCURSES_INCLUDE_DIRS})
-		link_directories(${NCURSES_LIBRARY_DIRS})
-	endif(NCURSES_FOUND)
+	set(CURSES_NEED_NCURSES TRUE)
+	set(CURSES_NEED_WIDE TRUE)
+	if(NOT CURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
+		set(CURSES_INCLUDE_PATH "/usr/local/include")
+	endif(NOT CURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
+	find_package(Curses REQUIRED)
+	if(CURSES_FOUND)
+		include_directories(${CURSES_INCLUDE_DIRS})
+	endif(CURSES_FOUND)
 endif(WITH_NCURSES)
 
 # Gettext
@@ -44,7 +39,7 @@
 
 # Libcpuid
 if(WITH_LIBCPUID)
-	pkg_check_modules(LIBCPUID libcpuid>=0.7.0)
+	pkg_check_modules(LIBCPUID REQUIRED libcpuid>=0.8.0)
 	if(LIBCPUID_FOUND)
 		include_directories(${LIBCPUID_INCLUDE_DIRS})
 		link_directories(${LIBCPUID_LIBRARY_DIRS})
@@ -55,7 +50,7 @@
 
 # Libpci
 if(WITH_LIBPCI)
-	pkg_check_modules(LIBPCI libpci)
+	pkg_check_modules(LIBPCI REQUIRED libpci)
 	if(LIBPCI_FOUND)
 		include_directories(${LIBPCI_INCLUDE_DIRS})
 		link_directories(${LIBPCI_LIBRARY_DIRS})
@@ -65,34 +60,30 @@
 
 # Libegl
 if(WITH_LIBEGL)
-	pkg_check_modules(LIBGL gl)
-	pkg_check_modules(LIBEGL egl>1.4)
-	if(LIBGL_FOUND AND LIBEGL_FOUND)
-		include_directories(${LIBGL_INCLUDE_DIRS} ${LIBEGL_INCLUDE_DIRS})
-		link_directories(${LIBGL_LIBRARY_DIRS} ${LIBEGL_LIBRARY_DIRS})
-		add_definitions(${LIBGL_CFLAGS_OTHER} ${LIBEGL_CFLAGS_OTHER})
-		set(LIBOPENGL_LIBRARIES ${LIBGL_LIBRARIES} ${LIBEGL_LIBRARIES})
-	endif(LIBGL_FOUND AND LIBEGL_FOUND)
+	pkg_check_modules(LIBEGL REQUIRED egl>1.4)
+	find_package(OpenGL REQUIRED COMPONENTS OpenGL EGL)
+	if(LIBEGL_FOUND AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
+		include_directories(${OPENGL_INCLUDE_DIRS} ${OPENGL_EGL_INCLUDE_DIRS})
+		set(LIBOPENGL_LIBRARIES OpenGL::OpenGL OpenGL::EGL)
+	endif(LIBEGL_FOUND AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
 endif(WITH_LIBEGL)
 
 # Vulkan
 if(WITH_VULKAN)
-	pkg_check_modules(VULKAN vulkan)
-	if(VULKAN_FOUND)
-		include_directories(${VULKAN_INCLUDE_DIRS})
-		link_directories(${VULKAN_LIBRARY_DIRS})
-		add_definitions(${VULKAN_CFLAGS_OTHER})
-	endif(VULKAN_FOUND)
+	find_package(Vulkan REQUIRED)
+	if(Vulkan_FOUND)
+		include_directories(${Vulkan_INCLUDE_DIRS})
+		set(LIBVUKLAN_LIBRARIES ${Vulkan_LIBRARIES})
+	endif(Vulkan_FOUND)
 endif(WITH_VULKAN)
 
 # OpenCL
 if(WITH_OPENCL)
-	pkg_check_modules(OPENCL OpenCL)
-	if(OPENCL_FOUND)
-		include_directories(${LIBOPENCL_INCLUDE_DIRS} ${OpenCL_INCLUDE_DIRS})
-		link_directories(${LIBOPENCL_LIBRARY_DIRS} ${OpenCL_LIBRARY_DIRS})
-		add_definitions(${LIBOPENCL_CFLAGS_OTHER} ${OpenCL_CFLAGS_OTHER})
-	endif(OPENCL_FOUND)
+	find_package(OpenCL REQUIRED)
+	if(OpenCL_FOUND)
+		include_directories(${OpenCL_INCLUDE_DIRS})
+		set(LIBOPENCL_LIBRARIES ${OpenCL_LIBRARIES})
+	endif(OpenCL_FOUND)
 endif(WITH_OPENCL)
 
 # Libprocps
@@ -100,7 +91,7 @@
 set(LIBSYSTEM 0)
 set(LIBPROC2 -1)
 if(WITH_LIBPROCPS AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
-	pkg_check_modules(LIBPROC2 libproc2)
+	pkg_check_modules(LIBPROC2 libproc2) # REQUIRED not present here to allow to fallback to libprocps
 	if(LIBPROC2_FOUND)
 		include_directories(${LIBPROC2_INCLUDE_DIRS})
 		link_directories(${LIBPROC2_LIBRARY_DIRS})
@@ -109,7 +100,7 @@
 		set(LIBSYSTEM 1)
 		set(LIBPROC2 1)
 	else()
-		pkg_check_modules(LIBPROCPS libprocps)
+		pkg_check_modules(LIBPROCPS REQUIRED libprocps)
 		set(LIBPROC2 0)
 	endif()
 	if(LIBPROCPS_FOUND)
@@ -123,7 +114,7 @@
 
 # Libstatgrab
 if(WITH_LIBSTATGRAB AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR FORCE_LIBSTATGRAB))
-	pkg_check_modules(LIBSTATGRAB libstatgrab)
+	pkg_check_modules(LIBSTATGRAB REQUIRED libstatgrab)
 	if(LIBSTATGRAB_FOUND)
 		include_directories(${LIBSTATGRAB_INCLUDE_DIRS})
 		link_directories(${LIBSTATGRAB_LIBRARY_DIRS})
@@ -141,13 +132,13 @@
 endif(WITH_DMIDECODE)
 
 # Bandwidth
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
+if(CPU_ISA_X86 AND WITH_BANDWIDTH)
 	add_subdirectory(core/bandwidth)
 	if(BANDWIDTH_FOUND)
 		include_directories(core/bandwidth)
 		set(BANDWIDTH_LIBRARIES "bandwidth")
 	endif(BANDWIDTH_FOUND)
-endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
+endif(CPU_ISA_X86 AND WITH_BANDWIDTH)
 
 
 ### FINAL CONFIG
@@ -155,29 +146,29 @@
 message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration (${CMAKE_SYSTEM_PROCESSOR}) **${ColourReset}")
 
 # UI libraries
-print_config("GTK"                 "${GTK3_VERSION}"        GTK3_FOUND        WITH_GTK)
-print_config("NCURSES"             "${NCURSES_VERSION}"     NCURSES_FOUND     WITH_NCURSES)
+print_config("GTK"                 "${GTK3_VERSION}"            WITH_GTK)
+print_config("NCURSES"             "${NCURSES_VERSION}"         WITH_NCURSES)
 
 # Other libraries
-print_config("GETTEXT"             0                        GETTEXT_FOUND     WITH_GETTEXT)
-print_config("LIBCPUID"            "${LIBCPUID_VERSION}"    LIBCPUID_FOUND    WITH_LIBCPUID)
-print_config("LIBPCI"              "${LIBPCI_VERSION}"      LIBPCI_FOUND      WITH_LIBPCI)
-print_config("LIBEGL"              "${LIBEGL_VERSION}"      LIBEGL_FOUND      WITH_LIBEGL)
-print_config("VULKAN"              "${VULKAN_VERSION}"      VULKAN_FOUND      WITH_VULKAN)
-print_config("OPENCL"              "${OPENCL_VERSION}"      OPENCL_FOUND      WITH_OPENCL)
+print_config("GETTEXT"             "${GETTEXT_VERSION_STRING}"  WITH_GETTEXT)
+print_config("LIBCPUID"            "${LIBCPUID_VERSION}"        WITH_LIBCPUID)
+print_config("LIBPCI"              "${LIBPCI_VERSION}"          WITH_LIBPCI)
+print_config("LIBEGL"              "${LIBEGL_VERSION}"          WITH_LIBEGL)
+print_config("VULKAN"              "${Vulkan_VERSION}"          WITH_VULKAN)
+print_config("OPENCL"              "${OpenCL_VERSION_STRING}"   WITH_OPENCL)
 if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
 	if(${LIBPROC2} EQUAL 1)
-		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"    LIBPROC2_FOUND    WITH_LIBPROCPS)
+		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"        WITH_LIBPROCPS)
 	else()
-		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"   LIBPROCPS_FOUND   WITH_LIBPROCPS)
+		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"       WITH_LIBPROCPS)
 	endif()
 else()
-	print_config("LIBSTATGRAB" "${LIBSTATGRAB_VERSION}" LIBSTATGRAB_FOUND WITH_LIBSTATGRAB)
+	print_config("LIBSTATGRAB"     "${LIBSTATGRAB_VERSION}"     WITH_LIBSTATGRAB)
 endif()
 
 # Subprojects
-print_config("DMIDECODE"           "${DMIDECODE_VERSION}"   1                 WITH_DMIDECODE)
-print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"   BANDWIDTH_FOUND   WITH_BANDWIDTH)
+print_config("DMIDECODE"           "${DMIDECODE_VERSION}"       WITH_DMIDECODE)
+print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"       WITH_BANDWIDTH)
 
 
 ### BINARIES
@@ -259,29 +250,29 @@
 endif(WITH_LIBPCI AND LIBPCI_FOUND)
 
 # Libegl
-if(WITH_LIBEGL AND LIBGL_FOUND AND LIBEGL_FOUND)
+if(WITH_LIBEGL AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
 	target_sources(${APP_EXEC}
 		PRIVATE
 		core/libopengl.cpp
 	)
-endif(WITH_LIBEGL AND LIBGL_FOUND AND LIBEGL_FOUND)
+endif(WITH_LIBEGL AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
 
 # Vulkan
-if(WITH_VULKAN AND VULKAN_FOUND)
+if(WITH_VULKAN AND Vulkan_FOUND)
 	target_sources(${APP_EXEC}
 		PRIVATE
 		core/libvulkan.cpp
 	)
-endif(WITH_VULKAN AND VULKAN_FOUND)
+endif(WITH_VULKAN AND Vulkan_FOUND)
 
 # OpenCL
-if(WITH_OPENCL AND OPENCL_FOUND)
+if(WITH_OPENCL AND OpenCL_FOUND)
 	target_sources(${APP_EXEC}
 		PRIVATE
 		core/libopencl.cpp
 		core/opencl_ext.h
 	)
-endif(WITH_OPENCL AND OPENCL_FOUND)
+endif(WITH_OPENCL AND OpenCL_FOUND)
 
 # Libsystem (libproc2/libprocps/libstatgrab)
 if(${LIBSYSTEM} GREATER 0)
@@ -332,9 +323,9 @@
 endif()
 
 # ARM CPUs workarounds
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64" AND CMAKE_SYSTEM_NAME MATCHES "Linux")
+if(CPU_ISA_ARM AND CMAKE_SYSTEM_NAME MATCHES "Linux")
 	set(OTHER_LIBRARIES "-latomic")
-endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64" AND CMAKE_SYSTEM_NAME MATCHES "Linux")
+endif(CPU_ISA_ARM AND CMAKE_SYSTEM_NAME MATCHES "Linux")
 
 # AppImage workarounds
 if(APPIMAGE)
@@ -377,12 +368,12 @@
 	std::filesystem
 
 	${GTK3_LIBRARIES}
-	${NCURSES_LIBRARIES}
+	${CURSES_LIBRARIES}
 	${LIBCPUID_LIBRARIES}
 	${LIBPCI_LIBRARIES}
 	${LIBOPENGL_LIBRARIES}
-	${VULKAN_LIBRARIES}
-	${OPENCL_LIBRARIES}
+	${LIBVUKLAN_LIBRARIES}
+	${LIBOPENCL_LIBRARIES}
 	${LIBSYSTEM_LIBRARIES}
 	${DMIDECODE_LIBRARIES}
 	${BANDWIDTH_LIBRARIES}
