=== debian/changelog ===
cpu-x (5.3.1-0.3) unstable; urgency=medium

  * NMU
  * disable BANDWIDTH option on x32, since it uses assembly code

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 14 May 2025 13:06:36 +0100

cpu-x (5.3.1-0.2) unstable; urgency=medium

  * NMU
  * Target unstable with ARM support

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 12 May 2025 21:39:05 +0100

cpu-x (5.3.1-0.1) experimental; urgency=medium

  * NMU
  * bump libcpuid-dev build dependency to 0.8.0 per upstream
  * forward port patches, the i686 check one is obsolete
  * Use libcpuid (>= 0.8.0-0.2) which supports ARM
  * Newly-Required build dependencies on Vulkan and OpenCL ICD loader

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 12 May 2025 18:06:36 +0100
