=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                cmake (>= 3.12),
                gawk,
                gettext,
-               libcpuid-dev (>= 0.7.1) [amd64 i386 x32],
+               libcpuid-dev (>= 0.8.0+repack1-0.3),
                libgtkmm-3.0-dev (>= 3.12),
                libcurl4-gnutls-dev,
                libegl-dev (>= 1.5),
@@ -18,7 +18,11 @@
                libproc2-dev,
                libstatgrab-dev,
                libvulkan-dev,
+	       vulkan-validationlayers,
+	       glslang-tools,
+	       glslc,
                opencl-headers,
+	       ocl-icd-opencl-dev,
                nasm,
                pkgconf,
                procps,
@@ -29,7 +33,7 @@
 Rules-Requires-Root: no
 
 Package: cpu-x
-Architecture: amd64 i386 arm64 armel armhf x32
+Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          procps,
